///File : ResistanceCalcul.cpp
//------------------------------------------------------------------------------
/*
    This file is part of resistancevalue.

    Resistancevalue is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Resistancevalue is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with resistancevalue.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "ResistanceColorDialog.hpp"
//------------------------------------------------------------------------------
DialogBandColorChoice::DialogBandColorChoice( wxWindow* parent, wxWindowID id, int colorNumber, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxDialog( parent, id, title, pos, size, style )
{
    m_ColorCodeResistance[0] = wxColour(0,0,0);
    m_ColorCodeResistance[1] = wxColour(184,134,11);
    m_ColorCodeResistance[2] = wxColour(255,0,0);
    m_ColorCodeResistance[3] = wxColour(255,165,0);
    m_ColorCodeResistance[4] = wxColour(255,255,0);
    m_ColorCodeResistance[5] = wxColour(154,205,50);
    m_ColorCodeResistance[6] = wxColour(100,149,237);
    m_ColorCodeResistance[7] = wxColour(238,130,238);
    m_ColorCodeResistance[8] = wxColour(160,160,160);
    m_ColorCodeResistance[9] = wxColour(255,255,255);

    wxBoxSizer *MainSizer = new wxBoxSizer( wxVERTICAL );

    wxGridSizer *SizerBitmapBtColor = new wxGridSizer(5);

    for(int i = 0; i < 10; i++)
    {
        wxImage tempImg(100,100);
        tempImg.SetRGB(wxRect(0,0,tempImg.GetWidth(), tempImg.GetHeight()), m_ColorCodeResistance[i].Red(), m_ColorCodeResistance[i].Green(), m_ColorCodeResistance[i].Blue());
        m_BitmapBtChoseColorTbl[i] = new wxBitmapButton(this, i, wxBitmap(tempImg));
        SizerBitmapBtColor->Add(m_BitmapBtChoseColorTbl[i], 1, wxEXPAND | wxALL, 5);
    }

    MainSizer->Add(SizerBitmapBtColor, 1, wxEXPAND);

    wxBoxSizer *SizerChoosenColor = new wxBoxSizer( wxHORIZONTAL );
    m_TxtChosenColor = new wxStaticText(this, wxID_ANY, _("Chosen color : "));
    SizerChoosenColor->Add(m_TxtChosenColor, 0, wxALIGN_CENTRE_VERTICAL);

    m_ImgChosenColor = new wxStaticBitmap(this, wxID_ANY, wxNullBitmap, wxDefaultPosition, wxSize(100, 50));
    SizerChoosenColor->Add(m_ImgChosenColor, 1);

    MainSizer->Add(SizerChoosenColor, 0, wxALL | wxALIGN_CENTRE, 5);

    wxSizer *btnSizer=CreateButtonSizer(wxOK|wxCANCEL);
    MainSizer->Add(btnSizer, 0, wxALL | wxALIGN_RIGHT, 5);

    SetSizer(MainSizer);

    SetColorNumber(colorNumber);
    this->Connect( 0, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor0));
    this->Connect( 1, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor1));
    this->Connect( 2, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor2));
    this->Connect( 3, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor3));
    this->Connect( 4, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor4));
    this->Connect( 5, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor5));
    this->Connect( 6, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor6));
    this->Connect( 7, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor7));
    this->Connect( 8, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor8));
    this->Connect( 9, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoice::OnButtonColor9));
}
//------------------------------------------------------------------------------
void DialogBandColorChoice::SetColorNumber(int colorNumber)
{
    wxImage tempImg(100,50);
    tempImg.SetRGB(wxRect(0,0,tempImg.GetWidth(), tempImg.GetHeight()), m_ColorCodeResistance[colorNumber].Red(), m_ColorCodeResistance[colorNumber].Green(), m_ColorCodeResistance[colorNumber].Blue());
    m_ImgChosenColor->SetBitmap(wxBitmap(tempImg));
    m_chosenColorNumber = colorNumber;
}
//------------------------------------------------------------------------------
int DialogBandColorChoice::GetColorNumber()
{
    return m_chosenColorNumber;
}
//------------------------------------------------------------------------------
DialogBandColorChoiceBand4::DialogBandColorChoiceBand4( wxWindow* parent, wxWindowID id, int colorNumber, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxDialog( parent, id, title, pos, size, style )
{
    m_ColorCodeResistance[0] = wxColour(255, 215, 0);
    m_ColorCodeResistance[1] = wxColour(192, 192, 192);
    //m_ColorCodeResistance[2] = wxColour(0, 0, 0);

    wxBoxSizer *MainSizer = new wxBoxSizer( wxVERTICAL );

    wxGridSizer *SizerBitmapBtColor = new wxGridSizer(3);

    for(int i = 0; i < 2; i++)
    {
        wxImage tempImg(100,100);
        tempImg.SetRGB(wxRect(0,0,tempImg.GetWidth(), tempImg.GetHeight()), m_ColorCodeResistance[i].Red(), m_ColorCodeResistance[i].Green(), m_ColorCodeResistance[i].Blue());
        m_BitmapBtChoseColorTbl[i] = new wxBitmapButton(this, i, wxBitmap(tempImg));
        SizerBitmapBtColor->Add(m_BitmapBtChoseColorTbl[i], 1, wxEXPAND | wxALL, 5);
    }

    m_BtRien = new wxButton(this, 2, _T("Ø"));
    SizerBitmapBtColor->Add(m_BtRien, 1, wxEXPAND | wxALL, 5);

    MainSizer->Add(SizerBitmapBtColor, 1, wxEXPAND);

    wxBoxSizer *SizerChoosenColor = new wxBoxSizer( wxHORIZONTAL );
    m_TxtChosenColor = new wxStaticText(this, wxID_ANY, _("Chosen color : "));
    SizerChoosenColor->Add(m_TxtChosenColor, 0, wxALIGN_CENTRE_VERTICAL);

    m_ImgChosenColor = new wxStaticBitmap(this, wxID_ANY, wxNullBitmap, wxDefaultPosition, wxSize(100, 50));
    SizerChoosenColor->Add(m_ImgChosenColor, 1);

    MainSizer->Add(SizerChoosenColor, 0, wxALL | wxALIGN_CENTRE, 5);

    wxSizer *btnSizer=CreateButtonSizer(wxOK|wxCANCEL);
    MainSizer->Add(btnSizer, 0, wxALL | wxALIGN_RIGHT, 5);

    SetSizer(MainSizer);

    SetColorNumber(colorNumber);
    this->Connect( 0, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoiceBand4::OnButtonColor0));
    this->Connect( 1, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoiceBand4::OnButtonColor1));
    this->Connect( 2, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(DialogBandColorChoiceBand4::OnButtonColor2));
}
//------------------------------------------------------------------------------
void DialogBandColorChoiceBand4::SetColorNumber(int colorNumber)
{
    if(colorNumber != 2)
    {
        wxImage tempImg(100,50);
        tempImg.SetRGB(wxRect(0,0,tempImg.GetWidth(), tempImg.GetHeight()), m_ColorCodeResistance[colorNumber].Red(), m_ColorCodeResistance[colorNumber].Green(), m_ColorCodeResistance[colorNumber].Blue());
        m_ImgChosenColor->SetBitmap(wxBitmap(tempImg));
    }
    else
    {
        wxImage tempImg(100,50);
        tempImg.SetRGB(wxRect(0,0,tempImg.GetWidth(), tempImg.GetHeight()), GetBackgroundColour().Red(), GetBackgroundColour().Green(), GetBackgroundColour().Blue());

        wxBitmap bmp(tempImg);
        wxMemoryDC dc;
        dc.SelectObject(bmp);

        //dc.DrawRectangle(wxRect(0, 0, dc.GetSize().GetWidth(), dc.GetSize().GetHeight()));
        dc.SetFont(wxFont(35, wxSWISS, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL ));
        dc.DrawText(_T("Ø"), 5, 0);

        m_ImgChosenColor->SetBitmap(bmp);
    }

    m_chosenColorNumber = colorNumber;
}
//------------------------------------------------------------------------------
int DialogBandColorChoiceBand4::GetColorNumber()
{
    return m_chosenColorNumber;
}
